/*----------------------------------------------------------------------------
Copyright (c)2000 TogetherSoft Corporation. Patents pending. All rights reserved.
----------------------------------------------------------------------------*/

package ProjActMgmt.ProjActRequest;

import java.util.Date;
import java.util.Vector;
import java.math.BigDecimal;
import ProjActMgmt.ProjAct.ProjectActivity;

/** 
 * @author TogetherSoft
 * @stereotype moment-interval
 * @alias ProjectActivityRequest
 */
public class ProjectActivityReq {
    public void makeProjectActivityRequest() {
    }

    public void complete() {
    }

    public void cancel() {
    }

    public int rateUrgency() {
        return 0;
    }

    public boolean mi_isFulfilled() {
        return false;
    }

    /**  */
    public BigDecimal mi_estimatePercentComplete() {
        return new BigDecimal(0);
    }

    public Vector mi_generateSubsequentRequests() {
        return new Vector();
    }

    public Vector mi_listHierarchy() {
        return new Vector();
    }

    public ProjectActivity mi_generatePlannedProjectActvityStartingAt() {
        return new ProjectActivity();
    }

    /**  */
    public Vector mi_compareEstimatedPlannedAndActualCost() {
        return new Vector();
    }

    public static ProjectActivityReq selectNextProjectActivityRequest() {
        return new ProjectActivityReq();
    }

    public static Vector forecastProjectActivityRequests() {
        return new Vector();
    }

    public static Vector listActivityProjectRequests() {
        return new Vector();
    }

    /**
     *@shapeType AggregationLink
     *  @supplierCardinality 0..*
     *  @supplierRole sub
     * @clientCardinality 0..1
     */
    private ProjectActivityReq lnkUnnamed;
    private String number;
    private int status;
    private int priority;
    private Date requestDate;
    private Date dueDate;
    private Date approvalDate;
    private String description;
    private String justification;
    private int estimatedDuration;
    private BigDecimal estimatedCost;
    private BigDecimal budget;

    /**
     * @supplierCardinality 0..*
     * @clientCardinality 1
     */
    private ProjActMgmt.ProjAct.ProjectActivity lnkUnnamed1;

    /** @supplierCardinality 1 */
    private IMakeProjectActivityReq lnkUnnamed4;

    /**
     *@shapeType AggregationLink
     * @associates <b>ProjActMgmt.ProjActRequest.ProjectActivityReqDetail</b>
     * @supplierCardinality 1..*
     * @clientCardinality 1
     */
    private Vector lnkUnnamed7;

    /**
     * @supplierCardinality 0..*
     * @clientCardinality 0..*
     */
    private AccountingMgmt.Budget.BudgetRequest lnkUnnamed2;

    /**
     * @supplierCardinality 0..1
     * @clientCardinality 0..*
     */
    private AccountingMgmt.Account.ProjectAccount lnkUnnamed3;
}


